Subject: Re: [PATCH 04/10] batman-adv: export compatibility version via debugfs

From: Antonio Quartulli <[email-masked]>
Date: Mon, 19 Nov 2012 22:09:56 +0100

On Mon, Nov 19, 2012 at 02:47:45PM -0500, David Miller wrote:
> From: Sven Eckelmann <[email-masked]>
> Date: Mon, 19 Nov 2012 20:29:07 +0100
> 
> > On Monday 19 November 2012 18:52:30 Ben Hutchings wrote:
> >> On Mon, 2012-11-19 at 09:24 +0100, Antonio Quartulli wrote:
> >> > Different versions of the batman-adv module may use the same compatibility
> >> > version, but this is not understandable at runtime (the only way is to
> >> > parse the kernel log and fetch the batman-adv advertisement message on
> >> > loading). The user may want to know whether two nodes using different
> >> > versions can communicate or not. For this purpose the module has to
> >> > export this value through debugfs.
> >> [...]
> >> 
> >> I do hope that you're not planning to use unstable debugfs interfaces
> >> indefinitely.
> > 
> > Why are you refering to the adding of an file as "incompatible" debugfs 
> > interface? I would call it additional information. And the rest of the commit 
> > message is talking about *possible* protocol incompatibilies of the network 
> > protocol (which caused this uncontrolled erruption of anger in a network 
> > maintainer).
> 
> Debugfs files aren't where you store information that userspace actually
> uses in normal situations.
> 
> It's for developer debug, to expose internals that otherwise have no
> business being part of the user visible interfaces.

Ok, you are right. As you already stated, I do see two problems here:
1) debugfs not used properly (this information is not really for "devs")
2) this compatibility version export is like the claim: "compatibility is broken
   everyday". But actually this is not what we really wanted.

This patch simply came from a feature request raised by a user of ours. As Sven
pointed out, we have seen it just as "more information available for network
debugging" and we (in particular me) didn't think about the fact that having
such a patch was against the "stabilisation" process that we are following (we
discussed about this process during the last pull request, so you already know
that we are already going towards this direction).

David, Ben, if you agree I would remove this patch and repost the pull request.

Regards,

-- 
Antonio Quartulli

..each of us alone is worth nothing..
Ernesto "Che" Guevara